#!/usr/local/bin/perl
# edit_newbw.cgi
# Display current bandwidth usage graphs, and allow enabling of scheduled
# checking

require './virtual-server-lib.pl';
&master_admin() || &error($text{'newbw_ecannot'});
&ui_print_header(undef, $text{'newbw_title'}, "");

$job = &find_bandwidth_job();
print "$text{'newbw_desc'}<br>\n";
print &ui_form_start("save_newbw.cgi", "post");
print &ui_table_start($text{'newbw_header'}, undef, 2);

# Show active field
print &ui_table_row($text{'newbw_active'},
		    &ui_radio("bw_active", $job && $config{'bw_active'} ? 1 : 0,
			      [ [ 1, $text{'yes'} ], [ 0, $text{'no'} ] ]));

# Show field for monitoring period
print &ui_table_row($text{'newbw_period'},
		    &ui_select("bw_past", $config{'bw_past'},
			[ [ 'week', $text{'newbw_past_week'} ],
			  [ 'month', $text{'newbw_past_month'} ],
			  [ 'year', $text{'newbw_past_year'} ],
			  [ '', $text{'newbw_past_'} ] ])."\n".
		    &ui_textbox("bw_period", $config{'bw_period'}, 4)." ".
		    $text{'newbw_days'});

# Show email to owner field
print &ui_table_row($text{'newbw_owner'},
		    &ui_radio("bw_owner", $config{'bw_owner'} ? 1 : 0,
			      [ [ 1, $text{'yes'} ], [ 0, $text{'no'} ] ]));

# Show email to other address
print &ui_table_row($text{'newbw_email'},
		    &ui_textbox("bw_email", $config{'bw_email'}, 30));

# Show field for notification period
print &ui_table_row($text{'newbw_notify'},
		    &ui_textbox("bw_notify", $config{'bw_notify'}, 5)."\n".
		    $text{'newbw_hours'});

# Show field for disable option
print &ui_table_row($text{'newbw_disable'},
		    &ui_radio("bw_disable", $config{'bw_disable'} ? 1 : 0,
			      [ [ 1, $text{'yes'} ], [ 0, $text{'no'} ] ]));

# Show email for domains over limit
$file = $config{'bw_template'};
$file = "$module_config_directory/bw-template" if ($file eq "default");
print &ui_table_row($text{'newbw_template'},
		    &ui_textarea("bw_template", &cat_file($file),
				5, 70));

# Show field for warning percentage
print &ui_table_row($text{'newbw_warn'},
    &ui_radio("bw_warn", $config{'bw_warn'} ? 1 : 0,
	      [ [ 1, &text('newbw_warnyes',
			   &ui_textbox("bw_warnlevel", $config{'bw_warn'},4)) ],
		[ 0, $text{'no'} ] ]));

# Show email for domains over limit
$file = $config{'warnbw_template'};
$file = "$module_config_directory/warnbw-template" if ($file eq "default");
print &ui_table_row($text{'newbw_warntemplate'},
		    &ui_textarea("warnbw_template", &cat_file($file),
				5, 70));

# Servers to check or exclude
if ($config{'bw_servers'} eq "") {
	$serversmode = 0;
	}
elsif ($config{'bw_servers'} =~ /^\!(.*)$/) {
	$serversmode = 2;
	@servers = split(/\s+/, $1);
	}
else {
	$serversmode = 1;
	@servers = split(/\s+/, $config{'bw_servers'});
	}
print &ui_table_row($text{'newbw_servers'},
		    &ui_radio("serversmode", $serversmode,
			      [ [ 0, $text{'newbw_servers0'} ],
			        [ 1, $text{'newbw_servers1'} ],
			        [ 2, $text{'newbw_servers2'} ] ])."<br>\n".
		    &servers_input("servers", \@servers,
				   [ &list_domains() ]));

# Log files for FTP and mail
$defftplog = &get_proftpd_log();
print &ui_table_row($text{'newbw_ftplog'},
	&ui_opt_textbox("ftplog", $config{'bw_ftplog'}, 40,
	  $defftplog ? &text('newbw_ftplogdef', "<tt>$defftplog</tt>")."<br>"
		     : $text{'newbw_ftplognone'},
	$text{'newbw_ftplogfile'})."<br>".
	&ui_checkbox("ftplog_rotated", 1, $text{'newbw_rotated'},
		     $config{'bw_ftplog_rotated'}));

print &ui_table_row($text{'newbw_maillog'},
	&ui_opt_textbox("maillog", $config{'bw_maillog'}, 40,
			$text{'newbw_ftplognone'},
			$text{'newbw_maillogfile'})."<br>".
	&ui_checkbox("maillog_rotated", 1, $text{'newbw_rotated'},
		     $config{'bw_maillog_rotated'}));

print &ui_table_end();
print &ui_form_end([ [ "save", $text{'save'} ] ]);

# Button to show graph
print "<hr>\n";
print &ui_buttons_start();
print &ui_buttons_row("bwgraph.cgi", $text{'newbw_graphbutton'},
				     $text{'newbw_graphdesc'});
print &ui_buttons_end();

&ui_print_footer("", $text{'index_return'});

