#!/usr/local/bin/perl
# Show one template for editing

require './virtual-server-lib.pl';
&master_admin() || &error($text{'newtmpl_ecannot'});
&ReadParse();

if ($in{'new'}) {
	&ui_print_header(undef, $text{'tmpl_title1'}, "");
	}
else {
	&ui_print_header(undef, $text{'tmpl_title2'}, "");
	@tmpls = &list_templates();
	($tmpl) = grep { $_->{'id'} == $in{'id'} } @tmpls;
	$tmpl || &error("Failed to find template with ID $in{'id'}");
	}

# Show description including template variables
print "$text{'tmpl_desc'}<br>\n";
&print_subs_table("DOM", "PREFIX", "USER", "IP", "HOME");

print &ui_form_start("save_tmpl.cgi", "post");
print &ui_hidden("id", $in{'id'}),"\n";
print &ui_hidden("new", $in{'new'}),"\n";
print &ui_table_start($text{'tmpl_header'}, "100%", 2);

# Name of this template - only editable for custom templates
print "<tr> <td><b>$text{'tmpl_name'}</b></td> <td>\n";
if ($tmpl->{'standard'}) {
	print "$tmpl->{'name'}\n";
	}
else {
	printf "<input name=name size=40 value='%s'>\n", $tmpl->{'name'};
	}
print "</td> </tr>\n";

# The skeleton files directory
print "<tr> <td><b>$text{'tmpl_skel'}</b></td> <td>\n";
print &none_def_input("skel", $tmpl->{'skel'}, $text{'tmpl_skeldir'}, 0,
		$tmpl->{'standard'} ? 1 : 0);
printf "<input name=skel size=40 value='%s'></td> </tr>\n",
	$tmpl->{'skel'} eq "none" ? undef : $tmpl->{'skel'};

# Who this template is suitable for
print "<tr> <td><b>$text{'tmpl_for'}</b></td> <td>\n";
foreach $f ("parent", "sub", "alias", "users") {
	if ($tmpl->{'standard'}) {
		if ($tmpl->{"for_".$f}) {
			print ",\n" if ($done_one_for++);
			print $text{'tmpl_for_'.$f},"\n";
			}
		}
	else {
		printf "<input type=checkbox name=for_%s value=1 %s> %s\n",
			$f, $tmpl->{"for_".$f} ? "checked" : "",
			$text{'tmpl_for_'.$f};
		}
	}
print "</td> </tr>\n";

print &ui_table_hr();

# Global ACL on or off
if (!$tmpl->{'default'}) {
	print "<tr> <td valign=top><b>$text{'tmpl_gacl'}</b></td> <td>\n";
	print &ui_radio("gacl", int($tmpl->{'gacl'}),
			   [ [ 0, $text{'default'} ],
			     [ 1, $text{'tmpl_gaclbelow'} ] ]),"</td>\n";
	}

# Global ACL users
print "<tr> <td valign=top><b>$text{'tmpl_gaclu'}</b></td> <td>\n";
printf "<input type=radio name=gacl_umode value=0 %s> %s\n",
	$tmpl->{'gacl_umode'} == 0 ? "checked" : "", $text{'tmpl_gacl0'};
printf "<input name=gacl_uusers size=40 value='%s'><br>\n",
	$tmpl->{'gacl_umode'} == 0 ? $tmpl->{'gacl_uusers'} : "";
printf "<input type=radio name=gacl_mode value=1 %s> %s\n",
	$tmpl->{'gacl_umode'} == 1 ? "checked" : "", $text{'tmpl_gacl1'};
printf "<input name=gacl_ugroups size=40 value='%s'></td> </tr>\n",
	$tmpl->{'gacl_umode'} == 1 ? $tmpl->{'gacl_ugroups'} : "";

# Global ACL groups
print "<tr> <td valign=top><b>$text{'tmpl_gaclg'}</b></td> <td>\n";
printf "<input name=gacl_groups size=40 value='%s'></td> </tr>\n",
	$tmpl->{'gacl_groups'};

# Global ACL root
print "<tr> <td valign=top><b>$text{'tmpl_gaclr'}</b></td> <td>\n";
printf "<input name=gacl_root size=40 value='%s'></td> </tr>\n",
	$tmpl->{'gacl_root'};

print &ui_table_hr();

# Defaults for new domain form
print &ui_table_row($text{'tmpl_ugroup'},
    &none_def_input("ugroup", $tmpl->{'ugroup'}, $text{'tmpl_ugroupsel'})."\n".
    &ui_textbox("ugroup", $tmpl->{'ugroup'} eq "none" ?
				"" : $tmpl->{'ugroup'}, 13)."\n".
    &group_chooser_button("ugroup"));

print &ui_table_row($text{'tmpl_quota'},
    &none_def_input("quota", $tmpl->{'quota'}, $text{'tmpl_quotasel'}, 1)."\n".
    &ui_textbox("quota", $tmpl->{'quota'} eq "none" ?
				"" : $tmpl->{'quota'}, 13));

print &ui_table_row($text{'tmpl_uquota'},
    &none_def_input("uquota", $tmpl->{'uquota'}, $text{'tmpl_quotasel'},1)."\n".
    &ui_textbox("uquota", $tmpl->{'uquota'} eq "none" ?
				"" : $tmpl->{'uquota'}, 13));

foreach $l ("mailbox", "dbs", "doms", "bw") {
	print &ui_table_row($text{'tmpl_'.$l.'limit'},
	    &none_def_input($l.'limit', $tmpl->{$l.'limit'},
			    $text{'tmpl_atmost'}, undef, undef,
			    $text{'form_unlimit'})."\n".
	    &ui_textbox($l.'limit', $tmpl->{$l.'limit'} eq "none" ?
					"" : $tmpl->{$l.'limit'}, 10));
	}

if ($config{'web'}) {
	# Apache directives and other settings
	print &ui_table_hr();

	print "<tr> <td valign=top><b>$text{'tmpl_web'}</b></td> <td>\n";
	print &none_def_input("web", $tmpl->{'web'}, $text{'tmpl_webbelow'}, 1);
	print "<textarea name=web rows=10 cols=60>";
	if ($tmpl->{'web'} ne "none") {
		print join("\n", split(/\t/, $tmpl->{'web'}));
		}
	print "</textarea>\n";

	print "<table>\n";

	# Input for adding suexec directives
	print "<tr> <td><b>$text{'newweb_suexec'}</b></td>\n";
	print "<td>",&ui_radio("suexec", $tmpl->{'web_suexec'} ? 1 : 0,
	       [ [ 1, $text{'yes'} ], [ 0, $text{'no'} ] ]),"</td> </tr>\n";

	# Input for logging via program
	print "<tr> <td><b>$text{'newweb_writelogs'}</b></td>\n";
	print "<td>",&ui_radio("writelogs", $tmpl->{'web_writelogs'} ? 1 : 0,
	       [ [ 1, $text{'yes'} ], [ 0, $text{'no'} ] ]),"</td> </tr>\n";

	# Input for Apache user to add to domain's group
	print "<tr> <td><b>$text{'newweb_user'}</b></td>\n";
	print "<td>",&ui_opt_textbox("user", $tmpl->{'web_user'}, 13,
				     $text{'no'}, $text{'newweb_useryes'}),"\n",
		     &user_chooser_button("user"),"</td> </tr>\n";

	# HTML sub-directory input
	print "<tr> <td valign=top><b>$text{'newweb_htmldir'}</b></td>\n";
	printf "<td nowrap><input type=radio name=html_dir_def value=1 %s> %s (%s)\n",
		$tmpl->{'web_html_dir'} ? "" : "checked", $text{'default'},
		"<tt>public_html</tt>";
	printf "<br><input type=radio name=html_dir_def value=0 %s> %s\n",
		$tmpl->{'web_html_dir'} ? "checked" : "", $text{'newweb_htmldir0'};
	printf "<input name=html_dir size=20 value='%s'><br>%s</td> </tr>\n",
		$tmpl->{'web_html_dir'}, ("&nbsp;" x 3).$text{'newweb_htmldir0suf'};
	$hdir = $tmpl->{'web_html_dir'} || "public_html";

	# HTML directory permissions
	print "<tr> <td><b>$text{'newweb_htmlperms'}</b></td>\n";
	print "<td>",&ui_textbox("html_perms", $tmpl->{'web_html_perms'}, 4),
	      "</td> </tr>\n";

	# Webalizer stats sub-directory input
	$smode = $tmpl->{'web_stats_hdir'} ? 2 :
		 $tmpl->{'web_stats_dir'} ? 1 : 0;
	print "<tr> <td valign=top><b>$text{'newweb_statsdir'}</b></td>\n";
	printf "<td nowrap><input type=radio name=stats_mode value=0 %s> %s (%s)\n",
		$smode == 0 ? "checked" : "", $text{'default'},
		"<tt>$hdir/stats</tt>";
	printf "<br><input type=radio name=stats_mode value=1 %s> %s\n",
		$smode == 1 ? "checked" : "",
		&text('newweb_statsdir0', "<tt>$hdir</tt>");
	printf "<input name=stats_dir size=20 value='%s'>\n",
		$tmpl->{'web_stats_dir'};
	printf "<br><input type=radio name=stats_mode value=2 %s> %s\n",
		$smode == 2 ? "checked" : "",
		&text('newweb_statsdir2', "<tt>$hdir</tt>");
	printf "<input name=stats_hdir size=20 value='%s'>\n",
		$tmpl->{'web_stats_hdir'};
	print "</td> </tr>\n";

	# Password-protect webalizer dir
	print "<tr> <td valign=top><b>$text{'newweb_statspass'}</b></td>\n";
	print "<td>",&ui_radio("statspass", $tmpl->{'web_stats_pass'} ? 1 : 0,
	       [ [ 1, $text{'yes'} ], [ 0, $text{'no'} ] ]),"</td> </tr>\n";

	# Alias mode
	print "<tr> <td valign=top><b>$text{'tmpl_alias'}</b></td> <td>\n";
	printf "<input type=radio name=alias_mode value=0 %s> %s<br>\n",
		$tmpl->{'web_alias'} == 0 ? "checked" : "", $text{'tmpl_alias0'};
	printf "<input type=radio name=alias_mode value=2 %s> %s<br>\n",
		$tmpl->{'web_alias'} == 2 ? "checked" : "", $text{'tmpl_alias2'};
	printf "<input type=radio name=alias_mode value=1 %s> %s<br>\n",
		$tmpl->{'web_alias'} == 1 ? "checked" : "", $text{'tmpl_alias1'};
	print "</td> </tr>\n";

	# Port for normal webserver
	print "<tr> <td><b>$text{'newweb_port'}</b></td>\n";
	printf "<td><input name=web_port size=6 value='%s'></td> </tr>\n",
		$tmpl->{'web_port'};

	# Port for SSL webserver
	print "<tr> <td><b>$text{'newweb_sslport'}</b></td>\n";
	printf "<td><input name=web_sslport size=6 value='%s'></td> </tr>\n",
		$tmpl->{'web_sslport'};

	if (&get_webmin_version() >= 1.201) {
		# Setup matching Webmin/Usermin SSL cert
		print "<tr> <td valign=top><b>",
		      "$text{'newweb_webmin'}</b></td>\n";
		print "<td>",&ui_radio("web_webmin_ssl",
		   $tmpl->{'web_webmin_ssl'} ? 1 : 0,
		   [ [ 1, $text{'yes'} ], [ 0, $text{'no'} ] ]),"</td> </tr>\n";

		print "<tr> <td valign=top><b>",
		      "$text{'newweb_usermin'}</b></td>\n";
		print "<td>",&ui_radio("web_usermin_ssl",
		   $tmpl->{'web_usermin_ssl'} ? 1 : 0,
		   [ [ 1, $text{'yes'} ], [ 0, $text{'no'} ] ]),"</td> </tr>\n";

		}
	print "</table></td> </tr>\n";

	# Webalizer template
	print &ui_table_row($text{'tmpl_webalizer'},
	    &none_def_input("webalizer", $tmpl->{'webalizer'},
			    $text{'tmpl_webalizersel'}, 0, 0,
			    $text{'tmpl_webalizernone'})."\n".
	    &ui_textbox("webalizer", $tmpl->{'webalizer'} eq "none" ?
					"" : $tmpl->{'webalizer'}, 40));
	}

if ($config{'dns'}) {
	# DNS directives
	print &ui_table_hr();

	print "<tr> <td valign=top><b>$text{'tmpl_dns'}</b></td> <td>\n";
	print &none_def_input("dns", $tmpl->{'dns'}, $text{'tmpl_dnsbelow'}, 1);
	print "<textarea name=dns rows=10 cols=60>";
	if ($tmpl->{'dns'} ne "none") {
		print join("\n", split(/\t/, $tmpl->{'dns'}));
		}
	print "</textarea>\n";

	print "<table>\n";

	print "<tr> <td><b>$text{'tmpl_replace'}</b></td> <td>\n";
	printf "<input type=radio name=bind_replace value=0 %s> %s\n",
		$tmpl->{'dns_replace'} ? "" : "checked", $text{'tmpl_replace0'};
	printf "<input type=radio name=bind_replace value=1 %s> %s</td> </tr>\n",
		$tmpl->{'dns_replace'} ? "checked" : "", $text{'tmpl_replace1'};

	&require_bind();
	$conf = &bind8::get_config();
	@views = &bind8::find("view", $conf);
	if (@views) {
		print "<tr> <td valign=top><b>$text{'newdns_view'}</b></td>\n";
		print "<td><select name=view>\n";
		printf "<option value='' %s>%s\n",
			$config{'dns_view'} eq "" ? "selected" : "",
			$text{'newdns_noview'};
		foreach $v (@views) {
			printf "<option value=%s %s>%s\n",
				$v->{'values'}->[0],
				$config{'dns_view'} eq $v->{'values'}->[0] ? "selected" : "",
				$v->{'values'}->[0];
			}
		print "</select></td> </tr>\n";
		}

	print "</table>\n";
	print "</td> </tr>\n";
	}

# FTP directives
if ($config{'ftp'}) {
	print &ui_table_hr();

	print "<tr> <td valign=top><b>$text{'tmpl_ftp'}</b></td> <td>\n";
	print &none_def_input("ftp", $tmpl->{'ftp'}, $text{'tmpl_ftpbelow'}, 1);
	print "<textarea name=ftp rows=10 cols=60>";
	if ($tmpl->{'ftp'} ne "none") {
		print join("\n", split(/\t/, $tmpl->{'ftp'}));
		}
	print "</textarea>\n";

	print "<table>\n";

	# Directory for anonymous FTP
	print "<tr> <td valign=top><b>$text{'newftp_dir'}</b></td>\n";
	printf "<td nowrap><input type=radio name=ftp_dir_def value=1 %s> %s (%s)\n",
		$tmpl->{'ftp_dir'} ? "" : "checked", $text{'default'},
		"<tt>ftp</tt>";
	printf "<br><input type=radio name=ftp_dir_def value=0 %s> %s\n",
		$tmpl->{'ftp_dir'} ? "checked" : "", $text{'newftp_dir0'};
	printf "<input name=ftp_dir size=20 value='%s'><br>%s</td> </tr>\n",
		$tmpl->{'ftp_dir'}, ("&nbsp;" x 3).$text{'newftp_dir0suf'};

	print "</table>\n";
	print "</td> </tr>\n";
	}

if ($config{'proxy_pass'} == 2) {
	# Frame-forwarding HTML (if enabled)
	print &ui_table_hr();

	print "<tr> <td valign=top><b>$text{'tmpl_frame'}</b></td> <td>\n";
	print &none_def_input("frame", $tmpl->{'frame'}, $text{'tmpl_framebelow'}, 1);
	print "<textarea name=frame rows=10 cols=60>";
	if ($tmpl->{'frame'} ne "none") {
		print join("\n", split(/\t/, $tmpl->{'frame'}));
		}
	print "</textarea></td> </tr>\n";
	}

# Email message for server creation
print &ui_table_hr();

print "<tr> <td valign=top><b>$text{'tmpl_mail'}</b></td> <td>\n";
print &none_def_input("mail", $tmpl->{'mail_on'}, $text{'tmpl_mailbelow'});
print "<br><textarea name=mail rows=10 cols=60>";
if ($tmpl->{'mail'} ne "none") {
	print join("\n", split(/\t/, $tmpl->{'mail'}));
	}
print "</textarea>\n";
print &email_template_input(undef, $tmpl->{'mail_subject'}, $tmpl->{'mail_cc'});
print "</td> </tr>\n";

print &ui_table_hr();

# Aliases for new users
print "<tr> <td valign=top><b>$text{'tmpl_aliases'}</b></td> <td>\n";
print &none_def_input("aliases", $tmpl->{'user_aliases'}, $text{'tmpl_aliasbelow'});
print "<br><table>\n";
@aliases = $tmpl->{'user_aliases'} eq "none" ? ( ) :
		split(/\t+/, $tmpl->{'user_aliases'});
&alias_form(\@aliases, undef,
	    undef, "user", "NEWUSER");
print "</table></td> </tr>\n";

# Aliases for new domains
@aliases = $tmpl->{'dom_aliases'} eq "none" ? ( ) :
		split(/\t+/, $tmpl->{'dom_aliases'});
print "<tr> <td valign=top><b>$text{'tmpl_domaliases'}</b></td> <td>\n";
print &none_def_input("domaliases", $tmpl->{'dom_aliases'}, $text{'tmpl_aliasbelow'});
print &ui_columns_start([ $text{'tmpl_aliasfrom'}, $text{'tmpl_aliasto'} ]);
$i = 0;
foreach $a (@aliases, undef, undef) {
	local ($from, $to) = split(/=/, $a, 2);
	print &ui_columns_row([
		&ui_textbox("alias_from_$i", $from, 20),
		&ui_textbox("alias_to_$i", $to, 40) ]);
	$i++;
	}
print &ui_columns_end(),"</td> </tr>\n";

# MySQL-related settings
print &ui_table_hr();

print "<tr> <td valign=top><b>$text{'tmpl_mysql'}</b></td> <td>\n";
print &none_def_input("mysql", $tmpl->{'mysql'}, $text{'tmpl_mysqlpat'}, 1);
print &ui_textbox("mysql", $tmpl->{'mysql'}, 20);
print "</td> </tr>\n";

print "<tr> <td valign=top><b>$text{'tmpl_mysql_wild'}</b></td> <td>\n";
print &none_def_input("mysql_wild", $tmpl->{'mysql_wild'}, $text{'tmpl_mysqlpat'}, 1);
print &ui_textbox("mysql_wild", $tmpl->{'mysql_wild'}, 20);

print "<tr> <td valign=top><b>$text{'tmpl_mysql_hosts'}</b></td> <td>\n";
print &none_def_input("mysql_hosts", $tmpl->{'mysql_hosts'}, $text{'tmpl_mysqlh'});
print &ui_textbox("mysql_hosts", $tmpl->{'mysql_hosts'} eq "none" ? "" : $tmpl->{'mysql_hosts'}, 40);

print "<tr> <td valign=top><b>$text{'tmpl_mysql_mkdb'}</b></td> <td>\n";
print &ui_radio("mysql_mkdb", $tmpl->{'mysql_mkdb'},
		[ [ 1, $text{'yes'} ], [ 0, $text{'no'} ],
		  ($tmpl->{'default'} ? ( ) : ( [ "", $text{'default'} ] ) ) ]);

print "<tr> <td valign=top><b>$text{'tmpl_mysql_nopass'}</b></td> <td>\n";
print &ui_radio("mysql_nopass", $tmpl->{'mysql_nopass'},
		[ [ 0, $text{'yes'} ], [ 1, $text{'no'} ],
		  ($tmpl->{'default'} ? ( ) : ( [ "", $text{'default'} ] ) ) ]);
print "</td> </tr>\n";

print &ui_table_end();

# Buttons to save, create or delete
print &ui_form_end([
	[ "save", $in{'new'} ? $text{'create'} : $text{'save'} ],
	!$in{'new'} && !$tmpl->{'standard'} ?
		( [ "delete", $text{'delete'} ] ) : ( )
	]);

&ui_print_footer("edit_newtmpl.cgi", $text{'newtmpl_return'},
		 "", $text{'index_return'});

# none_def_input(name, value, final-option, no-none, no-default, none-text)
sub none_def_input
{
local $rv;
local $mode = $_[1] eq "none" ? 0 :
	      $_[1] eq "" ? 1 : 2;
local @opts;
push(@opts, 0) if (!$_[3]);
push(@opts, 1) if (!$tmpl->{'default'} && !$_[4]);
push(@opts, 2);
if (@opts > 1) {
	local $m;
	foreach $m (@opts) {
		$rv .= &ui_oneradio("$_[0]_mode", $m,
			$m == 0 ? ($_[5] || $text{'newtmpl_none'}) :
			$m == 1 ? $text{'default'} : $_[2], $mode == $m)."\n";
		}
	}
else {
	$rv .= &ui_hidden("$_[0]_mode", $opts[0])."\n";
	}
return $rv;
}

