#!/usr/local/bin/perl
# Show a form for restoring a single virtual server, or a bunch

require './virtual-server-lib.pl';
&master_admin() || &error($text{'restore_ecannot'});
&ui_print_header(undef, $text{'restore_title'}, "");
&ReadParse();

print "<form action=restore.cgi method=post>\n";
print "<table border>\n";
print "<tr $tb> <td><b>$text{'restore_header'}</b></td> </tr>\n";
print "<tr $cb> <td><table>\n";

# Get source 
$dest = $config{'backup_dest'};
if (defined($in{'dom'})) {
	$d = &get_domain($in{'dom'});
	if ($d->{'backup_dest'}) {
		$dest = $d->{'backup_dest'};
		}
	elsif ($config{'backup_fmt'} == 0 && $dest) {
		$dest .= "/$d->{'dom'}.tar.gz";
		}
	}

# Show source file field
print "<tr> <td valign=top><b>$text{'restore_src'}</td>\n";
print "<td>",&show_backup_destination("src", $dest),"</td> </tr>\n";

# Show feature selection boxes
print "<tr> <td valign=top><b>$text{'restore_features'}</td> <td>\n";
foreach $f (@backup_features) {
	local $bfunc = "restore_$f";
	if (defined(&$bfunc) &&
	    ($config{$f} || $f eq "unix" || $f eq "virtualmin")) {
		printf "<input type=checkbox name=feature value=%s %s> %s\n",
			$f, $config{'backup_feature_'.$f} ? "checked" : "",
			$text{'backup_feature_'.$f} || $text{'feature_'.$f};
		local $ofunc = "show_restore_$f";
		if (defined(&$ofunc)) {
			local %opts = map { split(/=/, $_) }
					split(/,/, $config{'backup_opts_'.$f});
			local $ohtml = &$ofunc(\%opts);
			print $ohtml;
			}
		print "<br>\n";
		}
	}
print "</td> </tr>\n";

# Creation options
print "<tr> <td valign=top><b>$text{'restore_reuid'}</td>\n";
print "<td>",&ui_radio("reuid", 1, [ [ 1, $text{'yes'} ],
				     [ 0, $text{'no'} ] ]),"</td> </tr>\n";

print "</table></td></tr></table>\n";
print "<input type=submit value='$text{'restore_now'}'></form>\n";

&ui_print_footer("", $text{'index_return'});

